BoiunaSite/Controllers/CadastroController.cs
using System;
using Infraestrutura;
using Infraestrutura.Exceptions;
using Infraestrutura.Exceptions.Base;
using Infraestrutura.Geradores.Interfaces;
using Infraestrutura.Modelos;
using Infraestrutura.Serviços.Interfaces;
using Infraestrutura.Singletons.Interfaces;
using Infraestrutura.ViewModels.Interfaces;
using Infraestrutura.ViewModels;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using System.Linq;

namespace BoiunaSite.Controllers
{
    public class CadastroController : Controller
    {
        private readonly Contexto _contexto;
        private readonly ICadastroGerador<CadastroModelo> _geradorCadastro;
        private readonly IDadosValidaçãoGerador _geradorDadosValidação;
        private readonly IUploadServiço _uploader;
        private readonly IAmbienteSingleton _ambiente;
        private readonly IEmailServiço _email;
        private readonly IExtensõesUploadSingleton _extensões;
        private readonly IValidadorCadastroServiço _validadorCadastro;
        private readonly ICriptografiaServiço _criptografia;
        private readonly DbSet<CadastroModelo> _dadosCadastro;

        public CadastroController(Contexto contexto, ICadastroGerador<CadastroModelo> geradorCadastro, IDadosValidaçãoGerador geradorDadosValidação, 
            IUploadServiço uploader, IAmbienteSingleton ambiente, IEmailServiço email, 
            IExtensõesUploadSingleton extensões, IValidadorCadastroServiço validadorCadastro, ICriptografiaServiço criptografia)
        {
            _contexto = contexto;
            _geradorCadastro = geradorCadastro;
            _geradorDadosValidação = geradorDadosValidação;
            _uploader = uploader;
            _ambiente = ambiente;
            _email = email;
            _extensões = extensões;
            _validadorCadastro = validadorCadastro;
            _criptografia = criptografia;
            _dadosCadastro = _contexto.Set<CadastroModelo>();
        }

        public IActionResult Index()
        {
            return View("Proibido");
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Cadastrar(CadastroViewModel viewModel)
        {
            string uploadRGCPF = null;
            string uploadComprovanteEndereço = null;
            string uploadComprovanteBancário = null;
            string uploadFoto = null;
            string uploadDeclaraçãoResidência = null;
            string uploadRGCPFResponsável = null;
            string uploadFotoResponsável = null;

            try
            {
                uploadRGCPF = _uploader.FazerUpload(viewModel.RGCPF, _ambiente.PastaRGCPF, _extensões.ExtensõesPDF);
                uploadComprovanteEndereço = _uploader.FazerUpload(viewModel.ComprovanteResidência, _ambiente.PastaComprovanteResidência, _extensões.ExtensõesPDF);
                uploadComprovanteBancário = _uploader.FazerUpload(viewModel.ComprovanteBancário, _ambiente.PastaComprovanteBancário, _extensões.ExtensõesPDF);
                uploadFoto = _uploader.FazerUpload(viewModel.Foto, _ambiente.PastaFoto, _extensões.ExtensõesImagem);

                //Arquivo não obrigatório pode ser nulo, logo, só será feito o upload se o usuário tiver enviado algo
                if (!_uploader.ArquivoNulo(viewModel.DeclaraçãoResidência)) uploadDeclaraçãoResidência = _uploader.FazerUpload(viewModel.DeclaraçãoResidência, _ambiente.PastaDeclaraçãoResidência, _extensões.ExtensõesPDF);
                if (!_uploader.ArquivoNulo(viewModel.RGCPFResponsável)) uploadRGCPFResponsável = _uploader.FazerUpload(viewModel.RGCPFResponsável, _ambiente.PastaRGCPFResponsável, _extensões.ExtensõesPDF);
                if (!_uploader.ArquivoNulo(viewModel.FotoResponsável)) uploadFotoResponsável = _uploader.FazerUpload(viewModel.FotoResponsável, _ambiente.PastaFotoResponsável, _extensões.ExtensõesImagem);

                var token = _email.GerarToken();

                var cadastro = _geradorCadastro.NovoCadastro()
                    .ComDadosPessoais(viewModel.Nome, viewModel.CPF, viewModel.Nascimento, viewModel.Email, viewModel.Telefone)
                    .ComSenha(viewModel.Senha, viewModel.SenhaConfirmação)
                    .ComEndereço(viewModel.Endereço, viewModel.CEP, viewModel.Cidade)
                    .ComBanco(viewModel.NomeBanco, viewModel.Agência, viewModel.Conta)
                    .ComResponsável(viewModel.NomeResponsável, viewModel.CPFResponsável)
                    .ComDocumentos(uploadRGCPF, uploadComprovanteEndereço, uploadFoto, uploadDeclaraçãoResidência, uploadComprovanteBancário)
                    .ComDocumentosResponsável(uploadRGCPFResponsável, uploadFotoResponsável)
                    .ComToken(token)
                    .ParaCadastro();

                _validadorCadastro.Validar(cadastro);

                foreach (var item in _dadosCadastro)
                {
                    if (item.CPF == viewModel.CPF) throw new CPFExistenteException();
                    if (item.Email == viewModel.Email) throw new EmailExistenteException();
                }

                cadastro.Senha = _criptografia.Criptografar(cadastro.Senha);
                _dadosCadastro.Add(cadastro);
                _contexto.SaveChanges();

                try
                {
                    _email.EmailConfirmação(token, viewModel.Email);
                }
                catch
                {
                    throw new EnviarEmailException();
                }

                cadastro.Senha = "";
                cadastro.SenhaConfirmação = "";

                return View("Sucesso", cadastro);
            }
            catch (Exception e)
            {
                _uploader.DeletarUpload(uploadRGCPF);
                _uploader.DeletarUpload(uploadComprovanteBancário);
                _uploader.DeletarUpload(uploadComprovanteEndereço);
                _uploader.DeletarUpload(uploadDeclaraçãoResidência);
                _uploader.DeletarUpload(uploadRGCPFResponsável);
                _uploader.DeletarUpload(uploadFoto);
                _uploader.DeletarUpload(uploadFotoResponsável);

                IDadosValidaçãoViewModel validação;

                if (e is ExceptionBase)
                {
                    validação = _geradorDadosValidação.Gerar(true, e.Message);

                }
                else
                {
                    validação = _geradorDadosValidação.GerarErroInesperado();
                }

                viewModel.Validação = validação;
                return View("Index", viewModel);
            }
        }
    }
}

BoiunaSite/Controllers/CertificadosController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text.Json;
using System.Threading.Tasks;
using Infraestrutura.ViewModel;
using Infraestrutura.ViewModel.Interfaces;
using Infraestrutura.ViewModels;
using Microsoft.AspNetCore.Mvc;

namespace BoiunaSite.Controllers
{
    public class CertificadosController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        [HttpGet("[controller]/[action]/{código}")]
        public async Task<IActionResult> Verificar(string código)
        {
            var resultado = await RetornarVerificação(código);
            return View(resultado);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> VerificarFormulário(VerificarCertificadoViewModel dados)
        {
            var resultado = await RetornarVerificação(dados.Código);
            return View("Verificar", resultado);
        }

        private async Task<IVerificarCertificadoViewModel> RetornarVerificação(string Código)
        {
            var url = $"https://boiuna.portonacional.to.gov.br:5200/Certificados/Verificar/{Código}";
            using var cliente = new HttpClient();
            var resposta = await cliente.GetAsync(url);

            resposta.EnsureSuccessStatusCode();

            var retorno = JsonSerializer.Deserialize<VerificarCertificadoViewModel>(await resposta.Content.ReadAsStringAsync());

            retorno.Código = Código;

            return retorno;
        }
    }
}

BoiunaSite/Controllers/ContatoController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

namespace BoiunaSite.Controllers
{
    public class ContatoController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }
    }
}

BoiunaSite/Controllers/EncerramentoController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

namespace BoiunaSite.Controllers
{
    public class EncerramentoController : Controller
    {
        public IActionResult Minecraft()
        {
            return View();
        }

        public IActionResult Hackathon()
        {
            return View();
        }

        public IActionResult PódioHackathon()
        {
            return View();
        }

        public IActionResult PódioMinecraft()
        {
            return View();
        }
    }
}

BoiunaSite/Views/Shared/_Layout.cshtml
@inject Infraestrutura.Singletons.Interfaces.IAmbienteSingleton Ambiente

<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>BoiunaTech</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <img src="@Ambiente.BannerSuperior" alt="BoiunaTech 2020" class="img-fluid" id="BannerSuperior" style="min-width:100%" />
        <nav class="navbar navbar-expand-lg navbar-toggleable-lg navbar-dark bg-dark border-bottom box-shadow mb-3">
            <a class="navbar-brand" href="#">
                <img src="~/imgs/icone.png" class="d-inline-block align-self-center mb-1">
                <font class="font-weight-bold">BoiunaTech 2020</font>
            </a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>

            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav mr-auto">
                    <li class="nav-item active">
                        <a class="nav-link" asp-controller="Home" asp-action="Index">Início</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Home" asp-action="Inscritos" target="_blank">Lista de Inscritos</a>
                    </li>
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            Arquivos do BoiunaTech 2020
                        </a>
                        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                            <a class="dropdown-item" asp-controller="Encerramento" asp-action="Minecraft">Minecraft</a>
                            <a class="dropdown-item" asp-controller="Encerramento" asp-action="Hackathon">Hackathon</a>
                        </div>
                    </li>
                    <li class="nav-item dropdown">
                        <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                            Pódio
                        </a>
                        <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                            <a class="dropdown-item" asp-controller="Encerramento" asp-action="PódioMinecraft">Minecraft</a>
                            <a class="dropdown-item" asp-controller="Encerramento" asp-action="PódioHackathon">Hackathon</a>
                        </div>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Certificados" asp-action="Index">Certificados de Participação</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" asp-controller="Contato" asp-action="Index">Contato</a>
                    </li>
                </ul>
                <form class="form-inline my-2 my-lg-0 mr-2">

                    @if (User.Identity.IsAuthenticated && User.IsInRole("Competidor"))
                    {
                        <a class="btn btn-info my-2 my-sm-0" asp-controller="Competidor" asp-action="Index">
                            Painel
                        </a>
                    }
                    else if (User.Identity.IsAuthenticated && User.IsInRole("Admin"))
                    {
                        <a class="btn btn-info my-2 my-sm-0" asp-controller="Admin" asp-action="Painel">
                            Admin
                        </a>
                    }
                    else
                    {
                        <a class="btn btn-success my-2 my-sm-0" asp-controller="Competidor" asp-action="Logar">
                            Entrar
                        </a>
                    }

                </form>

                <form class="form-inline my-2 my-lg-0">
                    <a class="btn btn-success my-2 my-sm-0" asp-controller="Cadastro" asp-action="Index">Participar do BoiunaTech</a>
                </form>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted bg-white">
        <div class="container">
            &copy; 2020 BoiunaTech
        </div>

    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @RenderSection("Scripts", required: false)
</body>
</html>